/**
 * highlighted-sources
 */

var cProcess = require('child_process');
var fs = require('fs');
var through = require('through');

var sourcesResultObj = {};

var gotEnoughSample = false;

module.exports = function(file, options) {
	var requestedProjects = require('../../../' + options.launcherFilePath + '/_buildHelpers/_sourcesToPublish');
//	console.log(file);
	var content = '';
	var bufStr;
	
	return through(write, end);
	// callback (3rd arg) function is not used here
	
	function write(buf) {
		bufStr = buf.toString();
		// Don't know why a bug was introduced when creating the "bundle from formant" bundler
		if (bufStr === '"use strict";\n') {
			return;
		}
//		console.log(file);
		requestedProjects.forEach(function(projectName) {
			if (!sourcesResultObj[projectName])
				sourcesResultObj[projectName] = [];
			projectExp = new RegExp('[/\\\\]' + projectName + '.*?\.js$', 'i');
			
			if (projectExp.test(file)) {
				const fileName = file.match(/([^\\]*?)\.js$/)[1];
				sourcesResultObj[projectName].push({name : fileName, content : bufStr});
			}
		});
		
		
		return content += bufStr;
	}
	
	function end() {
		fs.writeFileSync(((options.pathToProject + '/') || '') + 'cache/stringifiedSources.js', 'module.exports = {sourcesAsStringArrays : ' + JSON.stringify(sourcesResultObj) + '};');
		// console.log(sourcesResultObj);
		this.queue(content);
		this.queue(null);
	}
}